=== debian/changelog ===
mariadb-connector-odbc (3.1.4-1) unstable; urgency=medium

  * New upstream version 3.1.4
  * salsa-ci: run reprotest, but allow it to fail

 -- Bernhard Schmidt <berni@debian.org>  Tue, 08 Oct 2019 20:44:07 +0200

mariadb-connector-odbc (3.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #930445)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 31 May 2019 19:40:33 +0200
