## mariadb-connector-odbc 3.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,10 +22,10 @@
 
 SET(MARIADB_ODBC_VERSION_MAJOR 3)
 SET(MARIADB_ODBC_VERSION_MINOR 1)
-SET(MARIADB_ODBC_VERSION_PATCH 4)
+SET(MARIADB_ODBC_VERSION_PATCH 9)
 SET(MARIADB_ODBC_VERSION_QUALITY "ga")
 
-SET(MARIADB_ODBC_VERSION "03.01.0004")
+SET(MARIADB_ODBC_VERSION "03.01.0009")
 
 SET(MARIADB_DEFAULT_PLUGINS_SUBDIR "plugin")
 CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/ma_odbc_version.h.in
@@ -57,8 +57,7 @@
                      ${CMAKE_SOURCE_DIR}/dsn/odbc_dsn.rc
                      ${CMAKE_SOURCE_DIR}/dsn/resource.h
                      ma_dsn.c
-                     ma_driver.c
-                     ma_error.c
+#                     ma_error.c
                      ma_common.c)
 
 MACRO(ADD_OPTION _name _text _default)
@@ -89,7 +88,7 @@
       ENDFOREACH()
     ENDFOREACH()
   ENDIF()
-  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
+  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)# -DWIN32_LEAN_AND_MEAN)
   SET(INSTALL_PLUGINDIR "${MARIADB_DEFAULT_PLUGINS_SUBDIR}")
 ELSE()
   # This has been done before C/C cmake scripts are included
@@ -101,7 +100,7 @@
   ENDIF()
   MESSAGE(STATUS "Libraries installation dir: ${INSTALL_LIB_SUFFIX}")
   SET(INSTALL_PLUGINDIR "${INSTALL_LIB_SUFFIX}/mariadb/plugin")
-  MESSAGE(STATUS "Autentication Plugins installation dir: ${INSTALL_PLUGINDIR}")
+  MESSAGE(STATUS "Authentication Plugins installation dir: ${INSTALL_PLUGINDIR}")
 ENDIF()
 
 IF(WIN32 OR WITH_OPENSSL OR "${WITH_SSL}" STREQUAL  "OPENSSL")
@@ -120,8 +119,6 @@
       #ENDIF()
 
       SET(PLATFORM_DEPENDENCIES ${PLATFORM_DEPENDENCIES} ${SSL_LIBRARIES})
-      # Temporary workarond for the (typo) issue in the c/c 3.1.4
-      SET(CRYT_LIBS ${SSL_LIBRARIES})
     ELSE()
       MESSAGE(FATAL_ERROR "OpenSSL not found. Please install OpenSSL or disable SSL support via option -DWITH_OPENSSL=Off")
     ENDIF()
@@ -132,6 +129,22 @@
 ELSE()
   MESSAGE(STATUS "Configuring to build without SSL support")
 ENDIF()
+
+IF(APPLE)
+  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
+  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
+  OPTION(WITH_IODBC "Build with iOdbc" ON)
+  CMAKE_POLICY(SET CMP0042 NEW)
+  CMAKE_POLICY(SET CMP0068 NEW)
+  set(CMAKE_INSTALL_RPATH "")
+  SET(CMAKE_INSTALL_NAME_DIR "")
+  SET(CMAKE_MACOSX_RPATH ON)
+ELSE()
+  OPTION(WITH_IODBC "Build with iOdbc" OFF)
+ENDIF()
+
+ADD_OPTION(WITH_UNIT_TESTS "build test suite" ON)
 
 IF(EXISTS ${CMAKE_SOURCE_DIR}/libmariadb)
   IF(GIT_BUILD_SRCPKG)
@@ -141,8 +154,14 @@
   ENDIF()
   MESSAGE(STATUS "Running C/C cmake scripts")
   INCLUDE(${CMAKE_SOURCE_DIR}/cmake/connector_c.cmake)
+
+  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/libmariadb/include)
+  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/libmariadb/include)
 ELSE()
   SET(USE_SYSTEM_INSTALLED_LIB TRUE)
+  # Adding mariadb subdirs of standard include locations
+  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} "/usr/local/include/mariadb")
+  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} "/usr/include/mariadb")
   MESSAGE(STATUS "There is no Connector/C sub-project folder, linking against libmariadb installed on the system")
 ENDIF()
 
@@ -151,12 +170,6 @@
   ADD_OPTION(WITH_SIGNCODE "Digitally sign files" OFF)
 ENDIF()
 
-IF(APPLE)
-  OPTION(WITH_IODBC "Build with iOdbc" ON)
-ELSE()
-  OPTION(WITH_IODBC "Build with iOdbc" OFF)
-ENDIF()
-#ADD_OPTION(WITH_UNIT_TESTS "build test suite" ON)
 #ADD_OPTION(WITH_SSL "Enables use of TLS/SSL library" ON)
 
 IF(WITH_SIGNCODE)
@@ -173,9 +186,6 @@
 
 INCLUDE(${CMAKE_SOURCE_DIR}/cmake/SearchLibrary.cmake)
 INCLUDE(${CMAKE_SOURCE_DIR}/cmake/SetValueMacro.cmake)
-
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/libmariadb/include)
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/libmariadb/include)
 
 IF(WIN32)
   INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/dsn)
@@ -203,15 +213,16 @@
                           ma_legacy_helpers.h
                           ma_typeconv.h
                           ma_bulk.h)
-  SET(DSN_DIALOG_FILES ${DSN_DIALOG_FILES}
-                          ma_platform_win32.c)
-
-  SET(PLATFORM_DEPENDENCIES ws2_32 Shlwapi)
+                        #  SET(DSN_DIALOG_FILES ${DSN_DIALOG_FILES}
+                        #  ma_platform_win32.c)
+
+			SET(PLATFORM_DEPENDENCIES ws2_32 Shlwapi Pathcch)
   IF (MSVC)
     MESSAGE(STATUS "MSVC_VERSION= ${MSVC_VERSION}") 
     IF (NOT(MSVC_VERSION LESS 1900))
       MESSAGE(STATUS "Configuring to link connector against legacy_stdio_definitions") 
-      SET(PLATFORM_DEPENDENCIES ${PLATFORM_DEPENDENCIES} legacy_stdio_definitions)
+      SET(LEGACY_STDIO legacy_stdio_definitions)
+      SET(PLATFORM_DEPENDENCIES ${PLATFORM_DEPENDENCIES} ${LEGACY_STDIO})
     ENDIF()
   ENDIF()
 ELSE()
@@ -251,7 +262,6 @@
 
 SET(CPACK_PACKAGE_VERSION ${MARIADB_ODBC_VERSION_MAJOR}.${MARIADB_ODBC_VERSION_MINOR}.${MARIADB_ODBC_VERSION_PATCH})
 
-SET(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
 SET(CPACK_COMPONENTS_ALL ClientPlugins ODBCLibs Documentation)
 #SET(CPACK_COMPONENTS_ALL ODBCLibs Documentation)
 SET(CPACK_COMPONENTS_ALL_IN_ONE_PACKAGE 1)
@@ -274,14 +284,12 @@
   ADD_DEFINITIONS(-DSQLCOLATTRIB_SQLLEN_PTR)
 ENDIF()
 
-# This is interim, we port ascii version to Linux first
 IF(WIN32)
   SET(UNICODE "W")
 ELSE()
   IF (DIRECT_LINK_TESTS)
     ADD_DEFINITIONS(-DHAVE_UNICODE)
   ENDIF()
-
 ENDIF()
 
 SET(LIBRARY_NAME "maodbc")
@@ -307,17 +315,7 @@
   ADD_LIBRARY(${LIBRARY_NAME} SHARED ${MARIADB_ODBC_SOURCES} maodbcu.rc)
   
   IF(APPLE)
-    SET_TARGET_PROPERTIES(${LIBRARY_NAME} PROPERTIES LINK_FLAGS "-Wl")
-  ELSE()
-    SET_TARGET_PROPERTIES(${LIBRARY_NAME} PROPERTIES LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/maodbc.def")
-  ENDIF()
-ENDIF()
-
-SET_TARGET_PROPERTIES(${LIBRARY_NAME} PROPERTIES LANGUAGE C)
-TARGET_LINK_LIBRARIES(${LIBRARY_NAME} ${MARIADB_CLIENT_TARGET_NAME} ${ODBC_INSTLIBS} ${PLATFORM_DEPENDENCIES})
-
-# Currently on Windows only
-IF(WIN32)
-  ADD_CUSTOM_COMMAND(TARGET maodbc POST_BUILD
-    COMMAND ${CMAKE_COMMAND} ARGS -DDRIVER_LIB_DIR=$<TARGET_FILE_DIR:maodbc>
-                                  -DPLUGINS_LIB_DIR=$<TARGET_FILE_DIR:dialog>
+    SET(MAODBC_INSTALL_RPATH "${ODBC_LIB_DIR}" "@loader_path" "/usr/local/opt/libiodbc" "/usr/local/iODBC/lib" "/usr/local/opt/openssl@1.1/lib" "/usr/local/opt/libressl/lib")
+    SET_TARGET_PROPERTIES(${LIBRARY_NAME}
+                          PROPERTIES LINK_FLAGS "-Wl"
+                                     INSTALL_RPATH_USE_LINK_PATH 0
