=== wininstall/CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 ENDIF()
 
 ADD_EXECUTABLE(change_dsns_driver change_dsns_driver.c ${CMAKE_SOURCE_DIR}/ma_dsn.c ${CMAKE_SOURCE_DIR}/ma_platform_win32.c ${CMAKE_SOURCE_DIR}/ma_common.c)
-TARGET_LINK_LIBRARIES(change_dsns_driver ${ODBC_LIBS} ${ODBC_INSTLIBS} legacy_stdio_definitions Shlwapi)
+TARGET_LINK_LIBRARIES(change_dsns_driver ${ODBC_LIBS} ${ODBC_INSTLIBS} legacy_stdio_definitions Shlwapi Pathcch)
 
 CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/wininstall/mariadb_odbc.xml.in
                ${CMAKE_BINARY_DIR}/wininstall/mariadb_odbc.xml)
@@ -92,11 +92,11 @@
 
 ADD_CUSTOM_TARGET(
         ODBC_WIX
-        DEPENDS mariadb_odbc.xml
+        DEPENDS mariadb_odbc.xm binaries_dir.xm
         COMMAND ${WIX_DIR}candle.exe -ext WixUIExtension -ext WixUtilExtension mariadb_odbc.xml -o mariadb_odbc.wixobj)
 
 ADD_DEPENDENCIES(${MSI_PACKAGE} ODBC_WIX)
-ADD_DEPENDENCIES(ODBC_WIX maodbc maodbcs change_dsns_driver binaries_dir.xml mariadb_odbc.xml)
+ADD_DEPENDENCIES(ODBC_WIX maodbc maodbcs change_dsns_driver)
 IF(NOT USE_SYSTEM_INSTALLED_LIB)
   ADD_DEPENDENCIES(ODBC_WIX maodbc maodbcs dialog caching_sha2_password auth_gssapi_client sha256_password mysql_clear_password)
 ENDIF()
