=== debian/changelog ===
mariadb-connector-odbc (3.1.9-1) unstable; urgency=medium

  [ Matthias Blümel ]
  * install driver into odbcinst.ini

  [ Bernhard Schmidt ]
  * New upstream version 3.1.9

 -- Bernhard Schmidt <berni@debian.org>  Fri, 14 Aug 2020 17:30:22 +0200
