=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/mariadb

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DMARIADB_LINK_DYNAMIC=yes -DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)/odbc

override_dh_install:
	dh_install
	mkdir -p debian/odbc-mariadb/usr/share/doc/odbc-mariadb/
	mv debian/odbc-mariadb/usr/docs/* debian/odbc-mariadb/usr/share/doc/odbc-mariadb/
	rmdir debian/odbc-mariadb/usr/docs
