=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
opts="pgpsigurlmangle=s%$%.asc%"

# Uncomment to examine an FTP server
ftp://ftp.osuosl.org/pub/mariadb/connector-odbc-(.*)/mariadb-connector-odbc-(.*)-ga-src\.tar\.gz debian uupdate
